@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo 벻Ҫִбļ && echo. && echo 밴˳ && pause>nul && exit

:runFlashCustomAction
color f9
@title %title% %version% - ˢԶ̼ [%serial_number%]
set /A failure_count=0
set /A total_failure_count=0
set skip_error_prompt=1

    call "%~dp0getPartitionTable.cmd"

    echo.
    echo ==^>  FB ģʽ
    %fastboot% -s %serial_number% oem fb_mode_set

    if exist "%TFS_ROOT%tools\custom\custom.cmd" (
        echo.
        echo ==^> ִԶ CMD ű
        call "%TFS_ROOT%tools\custom\custom.cmd"
        if !errorlevel! NEQ 0 (
            echo.
            echo 豸 [!serial_number!] ִԶűʧܣ
            goto :flashFailedLabel
        )

        if "!fully_customizable!" == "1" (
          goto :skipDoFlashCustom
        )

    )

    if "%device_is_qcom%" EQU "1" (
        call "%~dp0doFlashAPartQCOM.cmd"
        if "!device_has_super!" EQU "1" (
            call "%~dp0doFlashAPartSuper.cmd"
        )
        call "%~dp0doFlashBPartQCOM.cmd"
        goto :endFlashAPBP
    )

    if "%device_is_mtk%" EQU "1" (
        call "%~dp0doFlashAPartMTK.cmd"
        if "!device_has_super!" EQU "1" (
            call "%~dp0doFlashAPartSuper.cmd"
        )
        call "%~dp0doFlashBPartMTK.cmd"
        goto :endFlashAPBP
    )

    if "%device_is_slsi%" EQU "1" (
        call "%~dp0doFlashAPartSLSI.cmd"
        if "!device_has_super!" EQU "1" (
            call "%~dp0doFlashAPartSuper.cmd"
        )
        call "%~dp0doFlashBPartSLSI.cmd"
        goto :endFlashAPBP
    )

    :endFlashAPBP

    if %errorlevel% NEQ 0 (
        echo.
        echo 豸 [%serial_number%] ˢʧܡ
        goto :flashFailedLabel
    )
    set /A total_failure_count+=%failure_count%

    echo.
    echo ==^>  FB ģʽ
    %fastboot% -s %serial_number% oem fb_mode_clear

    for /F "usebackq tokens=*" %%C in (`%%fastboot%% -s "%%serial_number%%" getvar product 2^>^&1 ^>nul ^| %%grep%% "product:" ^| %%awk%% -F: "{print $2}" ^| %%sed%% "s@ @@g"`) do (
        set deviceName=%%C
    )

    if "%deviceName%" == "nash" ( set oem_as_vendor=1 )

    if "%oem_as_vendor%" == "1" (
        if exist vendor.img (
            echo.
            echo ʾ⵽Ͼɻͣ豸ƣ[!deviceName!]
            echo OEM Ϊ Vendor ʹã
            !mv! -f vendor.img oem.img
        )
    )

    if "%device_has_super%" EQU "1" (
        if "!skip_fastbootd_action!" NEQ "1" (
            call :doFastbootdActions
        )
    ) else (
        call "%~dp0doFlashSeparatedSuper.cmd"
    )

    :skipDoFlashCustom

    if "%finished_factory_reset%" == "1" (
        echo.
        echo ======== ڻָ ========

        call "%~dp0doFactoryReset.cmd"
        if !errorlevel! NEQ 0 (
            echo 豸 [!serial_number!] ָʧܡ
            goto :flashFailedLabel
        )
        set /A total_failure_count+=!failure_count!
    )

    if exist "%TFS_ROOT%tools\custom\customend.cmd" (
        echo.
        echo ==^> ִԶ CMD ű...
        call "%TFS_ROOT%tools\custom\customend.cmd"
        if !errorlevel! NEQ 0 (
            echo.
            echo 豸 [!serial_number!] ִԶűβʧܣ
            goto :flashFailedLabel
        )
    )

    if "%finished_reboot%" == "1" (
        echo.
        echo ==^> 豸
        %fastboot% -s %serial_number% reboot
    )

    if %total_failure_count% EQU 0 ( color f2 )
    echo.
    echo 豸 [%serial_number%] ȫɡ %total_failure_count% 

    :flashFailedLabel
    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:doFastbootdActions
    echo.
    echo ==^> 豸Ϊ̬ fastbootd ģʽ

    echo.
    echo ------  fastbootd ģʽ ------
    %fastboot% -s %serial_number% reboot fastboot
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش Fastbootd ʧܣ
        echo.
        goto :flashFailedLabel
    )

    ping -n 3 127.1 > nul 2>nul

    echo.
    echo ------  [%serial_number%] ------

    %fastboot% -s %serial_number% getvar serialno > nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش [%serial_number%] ʧܣ
        echo.
        goto :flashFailedLabel
    )

    call "%~dp0getFastbootdPT.cmd"

    call "%~dp0doFlashSeparatedSuper.cmd"

    set /A total_failure_count+=%failure_count%

    echo.
    REM reboot-bootloader.
    echo ------  fastboot ------
    %fastboot% -s %serial_number% reboot-bootloader
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش Fastboot ʧܣ
        echo.
        goto :flashFailedLabel
    )

    ping -n 6 127.1 > nul 2>nul

    echo.
    echo ------  [%serial_number%] ------

    %fastboot% -s %serial_number% getvar serialno > nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش [%serial_number%] ʧܣ
        echo.
        goto :flashFailedLabel
    )

exit /b 0
::
::
:tips
    echo.
    echo 밴˳
    pause > nul
::
::
:exit
exit
