@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo 벻Ҫִбļ && echo. && echo 밴˳ && pause>nul && exit

:runFullFlash
color f9
@title %title% %version% - ˢ̼ [%serial_number%]
set /A total_failure_count=0
set factory_reset=0

    call "%~dp0getPartitionTable.cmd"

    if "%1" == "" (
        color fc
        echo.
        echo شѡΪգ
        goto :tips
    ) else (
        set factory_reset=%1
    )

    if "%finished_factory_reset%" == "1" ( set factory_reset=1 )

    echo.
    echo ==^>  FB ģʽ
    %fastboot% -s %serial_number% oem fb_mode_set

    if exist "%TFS_ROOT%tools\custom\custom.cmd" (
        echo.
        echo ==^> ִԶ CMD ű
        call "%TFS_ROOT%tools\custom\custom.cmd"
        if !errorlevel! NEQ 0 (
            echo.
            echo 豸 [!serial_number!] ִԶűʧܣ
            goto :flashFailedLabel
        )
    )

    echo.
    echo ======== ˢ BL֣ ========

    if "%device_is_qcom%" EQU "1" (
        call "%~dp0doFlashBLPartQCOM.cmd"
        goto :endFlashBL
    )

    if "%device_is_mtk%" EQU "1" (
        call "%~dp0doFlashBLPartMTK.cmd"
        goto :endFlashBL
    )

    if "%device_is_slsi%" EQU "1" (
        call "%~dp0doFlashBLPartSLSI.cmd"
        goto :endFlashBL
    )

    :endFlashBL
    if %errorlevel% NEQ 0 (
        echo.
        echo 豸 [%serial_number%] BL֣ˢʧܡ
        goto :flashFailedLabel
    )

    if "%flashall_skip_reboot_bl%" EQU "1" (
        REM skip reboot-bootloader
        goto :endRebootBL
    )

    call :rebootBootloader
    call "%~dp0getPartitionTable.cmd"

    :endRebootBL

    echo.
    echo ======== ˢ BP֣ ========


    if "%device_is_qcom%" EQU "1" (
        call "%~dp0doFlashBPartQCOM.cmd"
        goto :endFlashBP
    )

    if "%device_is_mtk%" EQU "1" (
        call "%~dp0doFlashBPartMTK.cmd"
        goto :endFlashBP
    )

    if "%device_is_slsi%" EQU "1" (
        call "%~dp0doFlashBPartSLSI.cmd"
        goto :endFlashBP
    )

    :endFlashBP
    if %errorlevel% NEQ 0 (
        echo.
        echo 豸 [%serial_number%] BP֣ˢʧܡ
        goto :flashFailedLabel
    )
    set /A total_failure_count+=%failure_count%

    echo.
    echo ======== ˢ APϵͳ֣ ========

    if "%device_is_qcom%" EQU "1" (
        call "%~dp0doFlashAPartQCOM.cmd"
        goto :endFlashAP
    )

    if "%device_is_mtk%" EQU "1" (
        call "%~dp0doFlashAPartMTK.cmd"
        goto :endFlashAP
    )

    if "%device_is_slsi%" EQU "1" (
        call "%~dp0doFlashAPartSLSI.cmd"
        goto :endFlashAP
    )

    :endFlashAP

    if "%device_has_super%" EQU "1" (
        call "%~dp0doFlashAPartSuper.cmd"
    ) else (
        call "%~dp0doFlashAPartOldSystem.cmd"
    )

    if %errorlevel% NEQ 0 (
        echo.
        echo 豸 [%serial_number%] APϵͳ֣ˢʧܡ
        goto :flashFailedLabel
    )
    set /A total_failure_count+=%failure_count%

    if "%factory_reset%" == "1" (
        echo.
        echo ======== ڻָ ========

        call "%~dp0doFactoryReset.cmd"
        if !errorlevel! NEQ 0 (
            echo 豸 [!serial_number!] ָʧܡ
            goto :flashFailedLabel
        )
        set /A total_failure_count+=%failure_count%

        echo.
        echo ======== ջ ========

        call "%~dp0doEraseModemst.cmd"
        set /A total_failure_count+=%failure_count%
    ) else (
        echo.
        echo ָá
    )

    if exist "%TFS_ROOT%tools\custom\customend.cmd" (
        echo.
        echo ==^> ִԶ CMD űβ...
        call "%TFS_ROOT%tools\custom\customend.cmd"
        if !errorlevel! NEQ 0 (
            echo.
            echo 豸 [!serial_number!] ִԶűβʧܣ
            goto :flashFailedLabel
        )
    )

    echo.
    echo ==^>  FB ģʽ
    %fastboot% -s %serial_number% oem fb_mode_clear

    if "%finished_reboot%" == "1" (

        if "!device_is_mtk!" EQU "1" (
            call :rebootBootloader
        )
        echo.
        echo ==^> 豸
        %fastboot% -s %serial_number% reboot
    )

    if %total_failure_count% EQU 0 ( color f2 )
    echo.
    echo 豸 [%serial_number%] ȫɡ %total_failure_count% 

    :flashFailedLabel
    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:rebootBootloader
    echo.
    REM reboot-bootloader to apply new bootloader.
    echo ------  fastboot ------
    %fastboot% -s %serial_number% reboot-bootloader
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش Fastboot ʧܣ
        echo.
        goto :flashFailedLabel
    )

    ping -n 6 127.1 > nul 2>nul

    echo.
    echo ------  [%serial_number%] ------

    %fastboot% -s %serial_number% getvar serialno > nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo ش [%serial_number%] ʧܣ
        echo.
        goto :flashFailedLabel
    )

exit /b 0
::
:tips
    echo.
    echo 밴˳
    pause > nul
::
::
:exit
exit
